Description

The smart proxy launcher should support calling libsystemd's sd_notify API (or the equivalent, writing to the Unix socket) when

daemon mode is disabled and the service is listening for requests.

This would allow it to support systemd's notify service type where the service is started in the foreground and notifies the service

manager that it's ready before marking the service as up.

Using a notify/non-forking mode is preferable over daemonization as it simplifies setup, provides a more accurate service state

(instead of marking the service up as soon as the fork occurs), and should allow systemd to capture stdout/err from the main server

process.

Related issues:

Related to Packaging - Bug #12463: The default settings of foreman-proxy conf... Resolved 11/12/2015

Associated revisions

Revision 99e9e5bf - 05/09/2017 10:10 AM - Dominic Cleal

fixes #19480 - add systemd notify support

When started under systemd, the launcher now logs via the notify socket

API when all configured WEBrick servers have started so the service

state is reported accurately (rather than the daemonization point).

An example unit file is now shipped that uses a --no-daemonize

argument to override the config file, so misconfiguration will not

prevent the service from starting correctly.

History

#1 - 05/09/2017 07:10 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/525 added

#2 - 05/09/2017 11:01 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 99e9e5bf5843ea1f05c62febc24bd0da919adc98.

#3 - 05/10/2017 04:29 AM - Dominic Cleal

- Related to Bug #12463: The default settings of foreman-proxy conflict with it's systemd service unit. added
